#
#	Copyright (C) 2007, 2008, 2009. PARP Research Group.
#	<http://perception.inf.um.es>
#	University of Murcia, Spain.
#
#	This file is part of the QVision library.
#
#	QVision is free software: you can redistribute it and/or modify
#	it under the terms of the GNU Lesser General Public License as
#	published by the Free Software Foundation, version 3 of the License.
#
#	QVision is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU Lesser General Public License for more details.
#
#	You should have received a copy of the GNU Lesser General Public
#	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
#

#############################
#
#	File src.pro
#

################################
## GENERAL CONFIG
TEMPLATE = lib
TARGET = qvision
DESTDIR = ../lib
VERSION = 0.2.0

DEPENDPATH += .
INCLUDEPATH += . include/

RCC_DIR = ../build/rcc
MOC_DIR = ../build/moc
UI_DIR = ./ui
OBJECTS_DIR = ../build/obj

win32 : CONFIG += console		# Si se quiere imprimir por pantalla en Windows
QT += opengl xml

# caso de linux (por ahora), definimos extensiones OpenGL para YUV acelerado.
# unix:DEFINES += LINUX_GL_YUV_ACCEL

################################
## PACKAGES INFORMATION
include(../qvision.pri)

######################################################################
# Installation

# General files
install_base.path = $$INSTALL_PATH
install_base.files = ../*.pri ../README ../COPYING ../COPYING.LESSER

install_lib.path = $$INSTALL_PATH
install_lib.files = ../lib

install_doc.path = $$INSTALL_PATH/doc
install_doc.files = ../doc/html/*

install_include_ui.path = $$INSTALL_PATH/include/
install_include_ui.files = ui

install_include_resources.path = $$INSTALL_PATH/include
install_include_resources.files = resources

# Install directives
INSTALLS = 	install_base				\
		install_lib				\
		install_doc				\
		install_include_ui			\
		install_include_resources

################################
## DEPENDING PACKAGES FILES
# qvCore
HEADERS +=	qvcore/qvdefines.h			\
		qvcore/qvapplication.h			\
		qvcore/qvimagebuffer.h			\
		qvcore/qvgenericimage.h			\
		qvcore/qvimage.h			\
		qvcore/qvworker.h			\
		qvcore/qvcamera.h			\
		qvcore/qvpropertycontainer.h		\
		qvcore/qvpropertycontainerchange.h

SOURCES +=	qvcore/qvdefines.cpp			\
		qvcore/qvapplication.cpp		\
		qvcore/qvimagebuffer.cpp		\
		qvcore/qvgenericimage.cpp		\
		qvcore/qvimage.cpp			\
		qvcore/qvworker.cpp			\
		qvcore/qvcamera.cpp			\
		qvcore/qvpropertycontainer.cpp		\
		qvcore/qvpropertycontainerchange.cpp

# qvUtils
HEADERS +=	qvutils/qnamedpipe.h			\
		qvutils/qvcpustat.h			\
		qvutils/qvcpustatcontroler.h		\
		qvutils/qvsleeper.h			\
		qvutils/qtree.h				\
		qvutils/qvindexedstringlist.h

SOURCES +=	qvutils/qnamedpipe.cpp			\
		qvutils/qvcpustat.cpp			\
		qvutils/qvcpustatcontroler.cpp		\
		qvutils/qvsleeper.cpp			\
		qvutils/qvindexedstringlist.cpp

# qvIO
HEADERS +=	qvio/qvio.h			\
		qvio/qvcameraworker.h		\
		qvio/qvyuv4mpeg2cameraworker.h	\
		qvio/qvyuv4mpeg2recorder.h

SOURCES +=	qvio/qvio.cpp				\
		qvio/qvcameraworker.cpp			\
		qvio/qvyuv4mpeg2cameraworker.cpp	\
		qvio/qvyuv4mpeg2recorder.cpp

# Forms
RESOURCES = ./resources/qvision.qrc

FORMS +=	ui/qvcameraform.ui		\
		ui/qvisionform.ui		\
		ui/qvcameraformsmall.ui		\
		ui/qvworkerformsmall.ui		\
		ui/qvcameraworkerwidget.ui	\
		ui/qvcameraworkerwidgetsmall.ui

HEADERS +=	qvgui/qvcamerawidget.h			\
		qvgui/qvparamwidget.h			\
		qvgui/qvcamerawidgetsmall.h		\
		qvgui/qvcameraworkerwidget.h		\
		qvgui/qvcameraworkerwidgetsmall.h	\
		qvgui/qvparamsinspectorwidget.h		\
		qvgui/qvworkerinterfacesmall.h		\
		qvgui/qvcanvas.h			\
		qvgui/qvimagecanvas.h			\
		qvgui/qvgui.h				\
		qvgui/qvdefaultgui.h			\
		qvgui/qvisioninterface.h		\
		qvgui/qv3dcanvas.h			\
		qvgui/qv3dmodel.h

SOURCES +=	qvgui/qvcamerawidget.cpp		\
		qvgui/qvcamerawidgetsmall.cpp		\
		qvgui/qvcameraworkerwidget.cpp		\
		qvgui/qvcameraworkerwidgetsmall.cpp	\
		qvgui/qvcanvas.cpp			\
		qvgui/qvimagecanvas.cpp			\
		qvgui/qvgui.cpp				\
		qvgui/qvdefaultgui.cpp			\
		qvgui/qvparamsinspectorwidget.cpp	\
		qvgui/qvparamwidget.cpp			\
		qvgui/qvworkerinterfacesmall.cpp	\
		qvgui/qvisioninterface.cpp		\
		qvgui/qv3dcanvas.cpp			\
		qvgui/qv3dmodel.cpp

# qvQWT
HEADERS +=	qvgui/qvplot.h			\
		qvgui/qvcpuplot.h		\
		qvgui/qvnumericplot.h		\
		qvgui/qvhistogramplot.h		\
		qvgui/qvhistogramplot2.h	\
		qvgui/qvhistogram.h

SOURCES +=	qvgui/qvplot.cpp		\
		qvgui/qvcpuplot.cpp		\
		qvgui/qvnumericplot.cpp		\
		qvgui/qvhistogramplot.cpp	\
		qvgui/qvhistogramplot2.cpp	\
		qvgui/qvhistogram.cpp

# Designer
RESOURCES +=	qvgui/qvdesigner/resources/resources.qrc

HEADERS +=	qvgui/qvdesigner/slate/link.h			\
		qvgui/qvdesigner/slate/asinclink.h		\
		qvgui/qvdesigner/slate/sinclink.h		\
		qvgui/qvdesigner/slate/grouplink.h		\
		qvgui/qvdesigner/slate/sequenlink.h		\
		qvgui/qvdesigner/slate/node.h			\
		qvgui/qvdesigner/slate/groupnode.h		\
		qvgui/qvdesigner/slate/middlenode.h		\
		qvgui/qvdesigner/slate/inputnode.h		\
		qvgui/qvdesigner/slate/outputnode.h		\
		qvgui/qvdesigner/slate/slateview.h		\
		qvgui/qvdesigner/slate/insertaction.h		\
		qvgui/qvdesigner/slate/informer.h		\
		qvgui/qvdesigner/slate/slatewindow.h		\
		qvgui/qvdesigner/qvdesignergui.h		\
		qvgui/qvdesigner/facade/itemproperties.h	\
		qvgui/qvdesigner/facade/itemfactory.h		\
		qvgui/qvdesigner/facade/workerdialog.h		\
		qvgui/qvdesigner/facade/imagecanvasdialog.h	\
		qvgui/qvdesigner/facade/cameradialog.h		\
		qvgui/qvdesigner/facade/cameraworkerdialog.h

SOURCES += qvgui/qvdesigner/slate/link.cpp			\
		qvgui/qvdesigner/slate/asinclink.cpp		\
		qvgui/qvdesigner/slate/sinclink.cpp		\
		qvgui/qvdesigner/slate/grouplink.cpp		\
		qvgui/qvdesigner/slate/sequenlink.cpp		\
		qvgui/qvdesigner/slate/node.cpp			\
		qvgui/qvdesigner/slate/groupnode.cpp		\
		qvgui/qvdesigner/slate/middlenode.cpp		\
		qvgui/qvdesigner/slate/inputnode.cpp		\
		qvgui/qvdesigner/slate/outputnode.cpp		\
		qvgui/qvdesigner/slate/slateview.cpp		\
		qvgui/qvdesigner/slate/insertaction.cpp		\
		qvgui/qvdesigner/slate/informer.cpp		\
		qvgui/qvdesigner/slate/slatewindow.cpp		\
		qvgui/qvdesigner/qvdesignergui.cpp		\
		qvgui/qvdesigner/facade/itemproperties.cpp	\
		qvgui/qvdesigner/facade/itemfactory.cpp		\
		qvgui/qvdesigner/facade/workerdialog.cpp	\
		qvgui/qvdesigner/facade/imagecanvasdialog.cpp	\
		qvgui/qvdesigner/facade/cameradialog.cpp	\
		qvgui/qvdesigner/facade/cameraworkerdialog.cpp

# qvIP
HEADERS +=	qvip/qvip.h		\
		qvip/qvpolyline.h	\
		qvip/qvpolylinef.h

SOURCES +=	qvip/qvip.cpp		\
		qvip/qvpolyline.cpp	\
		qvip/qvpolylinef.cpp

# qvIPP
HEADERS +=	qvip/qvipp/qvipp.h

SOURCES +=	qvip/qvipp/qvipp.cpp		\
		qvip/qvipp/qvippfunctions.cpp

# qvImageFeatures
HEADERS +=	qvip/qvimagefeatures/qvcomponenttree.h		\
		qvip/qvimagefeatures/qvmser.h

SOURCES +=	qvip/qvimagefeatures/qvcomponenttree.cpp	\
		qvip/qvimagefeatures/qvmser.cpp

# qvMath
SOURCES +=	qvmath/qvmath.cpp			\
		qvmath/qvtensorindex.cpp		\
		qvmath/qvtensorindexator.cpp		\
		qvmath/qvtensor.cpp			\
		qvmath/qvmatrixalgebra.cpp		\
		qvmath/qvmatrix.cpp			\
		qvmath/qvvector.cpp			\
		qvmath/qvfunction.cpp			\
		qvmath/qvquaternion.cpp			\
		qvmath/qvrationalnumber.cpp		\
		qvmath/qvdisjointset.cpp		\
		qvmath/qvcombinationiterator.cpp	\
		qvmath/qvprojective.cpp			\
		qvmath/qvnumericalanalysis.cpp		\
		qvmath/qvsampleconsensus.cpp		\
		qvmath/qv2dmap.cpp

HEADERS +=	qvmath/qvmath.h				\
		qvmath/qvblasdatabuffer.h		\
		qvmath/qvtensorindex.h			\
		qvmath/qvtensorindexator.h		\
		qvmath/qvtensor.h			\
		qvmath/qvmatrixalgebra.h		\
		qvmath/qvvector.h			\
		qvmath/qvfunction.h			\
		qvmath/qvquaternion.h			\
		qvmath/qvrationalnumber.h		\
		qvmath/qvdisjointset.h			\
		qvmath/qvcombinationiterator.h		\
		qvmath/qvprojective.h			\
		qvmath/qvnumericalanalysis.h		\
		qvmath/qvsampleconsensus.h		\
		qvmath/qv2dmap.h

# Workers
SOURCES +=	qvworkers/qvimageresizerworker.cpp	\
		qvworkers/qvimageretarderworker.cpp	\
		qvworkers/qvplanarrectifierworker.cpp	\
		qvworkers/qvharrispointdetector.cpp	\
		qvworkers/qvcannyedgedetector.cpp	\
		qvworkers/qvmserdetector.cpp		\
		qvworkers/qvhessianpointdetector.cpp	\
		qvworkers/qvimagemeansworker.cpp	\
		qvworkers/qvsynchronizerworker.cpp	\
		qvworkers/qvpointworker.cpp		\
		qvworkers/qvippworkers.cpp

HEADERS +=	qvworkers/qvimageresizerworker.h	\
		qvworkers/qvimageretarderworker.h	\
		qvworkers/qvplanarrectifierworker.h	\
		qvworkers/qvharrispointdetector.h	\
		qvworkers/qvcannyedgedetector.h		\
		qvworkers/qvmserdetector.h		\
		qvworkers/qvhessianpointdetector.h	\
		qvworkers/qvimagemeansworker.h		\
		qvworkers/qvsynchronizerworker.h	\
		qvworkers/qvpointworker.h		\
		qvworkers/qvippworkers.h

# Install header files
install_include.path =				$$INSTALL_PATH/include/
install_include_qvcore.path =			$$INSTALL_PATH/include/qvcore
install_include_qvgui.path =			$$INSTALL_PATH/include/qvgui
install_include_qvdesigner.path =		$$INSTALL_PATH/include/qvgui/qvdesigner
install_include_qvdesigner_slate.path =		$$INSTALL_PATH/include/qvgui/qvdesigner/slate
install_include_qvdesigner_resources.path =	$$INSTALL_PATH/include/qvgui/qvdesigner/resources
install_include_qvdesigner_facade.path =	$$INSTALL_PATH/include/qvgui/qvdesigner/facade
install_include_qvworkers.path =		$$INSTALL_PATH/include/qvworkers
install_include_qvip.path =			$$INSTALL_PATH/include/qvip
install_include_qvipp.path =			$$INSTALL_PATH/include/qvip/qvipp
install_include_qvimagefeatures.path =		$$INSTALL_PATH/include/qvip/qvimagefeatures
install_include_qvio.path =			$$INSTALL_PATH/include/qvio
install_include_qvutils.path =			$$INSTALL_PATH/include/qvutils
install_include_qvmath.path =			$$INSTALL_PATH/include/qvmath
install_include_ui.path =			$$INSTALL_PATH/include/

install_include.files =				QV* *.h
install_include_qvcore.files =			qvcore/*.h
install_include_qvgui.files =			qvgui/*.h
install_include_qvdesigner.files =		qvgui/qvdesigner/*.h
install_include_qvdesigner_slate.files =	qvgui/qvdesigner/slate/*.h
install_include_qvdesigner_resources.files =	qvgui/qvdesigner/resources
install_include_qvdesigner_facade.files =	qvgui/qvdesigner/facade/*.h
install_include_qvworkers.files =		qvworkers/*.h
install_include_qvip.files =			qvip/*.h
install_include_qvipp.files =			qvip/qvipp/*.h
install_include_qvimagefeatures.files =		qvip/qvimagefeatures/*.h
install_include_qvio.files =			qvio/*.h
install_include_qvutils.files =			qvutils/*.h
install_include_qvmath.files =			qvmath/*.h
install_include_ui.files =			ui

INSTALLS +=	install_include				\
		install_include_qvcore			\
		install_include_qvgui			\
		install_include_qvdesigner		\
		install_include_qvdesigner_slate	\
		install_include_qvdesigner_facade	\
		install_include_qvip			\
		install_include_qvipp			\
		install_include_qvimagefeatures		\
		install_include_qvio			\
		install_include_qvutils			\
		install_include_qvmath			\
		install_include_qvworkers

####################################################
# CUDA module
qvcuda	{
	SOURCES +=	qvcuda/qvcudaip.cpp			\
			qvcuda/qvcudautils.cpp

	HEADERS +=	qvcuda/qvcudaip.h			\
			qvcuda/qvcudautils.h			\
			qvcuda/qvcudaimage.h			\
			qvcuda/qvcudaipD.h

	CUDA_SOURCES +=	qvcuda/qvcudaipD.cu

	install_include_qvcuda.path = $$INSTALL_PATH/include/qvcuda
	install_include_qvcuda.files = qvcuda/*.h

	INSTALLS += install_include_qvcuda
	}

# MPlayer compatibility
qvmplayercamera	{
		HEADERS +=	qvio/qvmplayerreader.h		\
				qvio/qvmplayerproxy.h		\
				qvio/qvmplayercamera.h		\
				qvio/qvmplayercameraworker.h
		
		SOURCES +=	qvio/qvmplayerreader.cpp	\
				qvio/qvmplayerproxy.cpp		\
				qvio/qvmplayercamera.cpp	\
				qvio/qvmplayercameraworker.cpp
		}
